#include "inkey.ch"
#include "tbrowse.ch"

PROCEDURE Main

   LOCAL oConexao, oRs, aSQLList := Array(7), GetList := {}, nQtd, oTBrowse, cSQL, oElement, lErro, X

   AFill( aSQLList, Space(500) )
   oConexao := ConexaoMySql( hb_CWD() )
   oConexao:Open()
   SetMode(40,100)
   SetColor("W/B")
   CLS
   DO WHILE .T.
      CLS
      @ MaxRow()-6, 0 GET aSQLList[1] PICTURE "@KS90"
      @ MaxRow()-5, 0 GET aSQLList[2] PICTURE "@KS90"
      @ MaxRow()-4, 0 GET aSQLList[3] PICTURE "@KS90"
      @ MaxRow()-3, 0 GET aSQLList[4] PICTURE "@KS90"
      @ MaxRow()-2, 0 GET aSQLList[5] PICTURE "@KS90"
      @ MaxRow()-1, 0 GET aSQLList[6] PICTURE "@KS90"
      @ MaxRow()-0, 0 GET aSQLList[7] PICTURE "@KS90"
      READ
      IF LastKey() == K_ESC
         EXIT
      ENDIF
      Ajusta( @aSQLList )
      lErro := .T.
      BEGIN SEQUENCE WITH __BreakBlock()
         cSQL := ""
         FOR EACH oElement IN aSQLList
            cSQL += AllTrim( oElement ) + " "
         NEXT
         @ 2, 0 SAY "Executando"
         oRs := oConexao:Execute( cSQL )
         @ 3, 0 SAY "Fim"
         oTBrowse := {}
         nQtd := oRs:Fields:Count()
         IF nQTD > 0; AAdd( oTBrowse, { oRs:Fields( 0 ):Name, { || oRs:Fields( 0 ):Value } } ) ; ENDIF
         IF nQTD > 1; AAdd( oTBrowse, { oRs:Fields( 1 ):Name, { || oRs:Fields( 1 ):Value } } ) ; ENDIF
         IF nQTD > 2; AAdd( oTBrowse, { oRs:Fields( 2 ):Name, { || oRs:Fields( 2 ):Value } } ) ; ENDIF
         IF nQTD > 3; AAdd( oTBrowse, { oRs:Fields( 3 ):Name, { || oRs:Fields( 3 ):Value } } ) ; ENDIF
         IF nQTD > 4; AAdd( oTBrowse, { oRs:Fields( 4 ):Name, { || oRs:Fields( 4 ):Value } } ) ; ENDIF
         IF nQTD > 5; AAdd( oTBrowse, { oRs:Fields( 4 ):Name, { || oRs:Fields( 5 ):Value } } ) ; ENDIF
         IF nQTD > 6; AAdd( oTBrowse, { oRs:Fields( 4 ):Name, { || oRs:Fields( 6 ):Value } } ) ; ENDIF
         IF nQTD > 7; AAdd( oTBrowse, { oRs:Fields( 4 ):Name, { || oRs:Fields( 7 ):Value } } ) ; ENDIF
         IF nQTD > 8; AAdd( oTBrowse, { oRs:Fields( 4 ):Name, { || oRs:Fields( 8 ):Value } } ) ; ENDIF
         IF nQTD > 9; AAdd( oTBrowse, { oRs:Fields( 4 ):Name, { || oRs:Fields( 9 ):Value } } ) ; ENDIF
         BrowseADO( oRs, oTBrowse )
         lErro := .F.
      ENDSEQUENCE
      IF lErro
         BEGIN SEQUENCE WITH __BreakBlock()
            x := LTrim( Str( oConexao:Errors( 0 ):Number( ) ) ) + " " + oConexao:Errors( 0 ):Description()
            @ 4, 0 SAY ""
            DO WHILE LEN( x ) > 0
               @ Row() + 1, 0 SAY Left( x, MaxCol() )
               x := Substr( x, MaxCol() + 1 )
            ENDDO
            @ ROW() + 1, 0 SAY "Tecle ENTER"
            Inkey(0)
         ENDSEQUENCE
      ENDIF
   ENDDO

   RETURN

FUNCTION ConexaoMySql( cPath )

   LOCAL oConexao := win_OleCreateObject( "ADODB.Connection" )

   oConexao:ConnectionString := "Provider=Advantage OLE DB Provider;" + ;
      "Mode=Share Deny None;" + ;
      "Show Deleted Records in DBF Tables with Advantage=False;" + ;
       "Data Source=" + cPath + ";Advantage Server Type=ADS_Local_Server;" + ;
       "TableType=ADS_CDX;Security Mode=ADS_IGNORERIGHTS;" + ;
       "Lock Mode=Compatible;" + ;
       "Use NULL values in DBF Tables with Advantage=True;" + ;
       "Exclusive=No;Deleted=No;"
   oConexao:CursorLocation := 3
   oConexao:CommandTimeOut := 100

   RETURN oConexao

FUNCTION BrowseADO( oTemporario, oTBrowse )

   LOCAL oBrowse, nKey, oElement

   oBrowse := TBrowseDB():new( 04, 3, MaxRow() - 7, MaxCol() - 3 )

   oBrowse:goTopBlock  := { || oTemporario:moveFirst() }
   oBrowse:goBottomBlock := { || oTemporario:moveLast() }
   oBrowse:skipBlock  := { | n | ADOSkipper( oTemporario, n ) }

   FOR EACH oElement IN oTBrowse
      oBrowse:AddColumn( TBColumnNew( oElement[ 1 ], oElement[ 2 ] ) )
   NEXT

   DO WHILE .T.
      oBrowse:forceStable()
      nKey := Inkey(0)
      DO CASE
      CASE oBrowse:ApplyKey( nKey ) == TBR_EXIT
         EXIT
      ENDCASE
   ENDDO

   RETURN NIL

STATIC FUNCTION ADOSkipper( oTemporario, nSkip )

   LOCAL nRec := oTemporario:AbsolutePosition

   IF ! ( oTemporario:Eof )
      oTemporario:Move( nSkip )
      IF oTemporario:Eof
         oTemporario:moveLast()
      ENDIF
      IF oTemporario:Bof
         oTemporario:moveFirst()
      ENDIF
   ENDIF

   RETURN oTemporario:AbsolutePosition - nRec

STATIC FUNCTION Ajusta( aSQLList )

   LOCAL cSql, nPos, nLine, oElement
   cSQL := ""
   FOR EACH oElement IN aSQLList
      cSql += Trim( oElement ) + " "
   NEXT
   cSql := AllTrim( cSQL )
   AFill( aSQLList, "" )
   nLine := 1
   DO WHILE Len( cSQL ) != 0
      nPos := RAt( " ", Substr( cSQL + " ", 1, MaxCol() - 20 ) )
      aSQLList[ nLine ] := Substr( cSQL, 1, nPos )
      cSQL := AllTrim( Substr( cSQL, nPos + 1 ) )
      nLine += 1
   ENDDO
   FOR EACH oElement IN aSQLList
      oElement := Pad( oElement, 500 )
   NEXT

   RETURN NIL


FUNCTION AppUserName(); RETURN ""
FUNCTION AppVersaoExe(); RETURN ""
